package jalview.ws.api;

/**
 * Service UI Info { Action, Specific Name of Service, Brief Description }
 */

public class UIinfo
{
  private String ServiceType;

  public UIinfo(String serviceType, String action, String name,
          String description)
  {
    this.setServiceType(serviceType == null ? "" : serviceType);
    this.Action = action == null ? "" : action;
    this.description = description == null ? "" : description;
    this.Name = name == null ? "" : name;
  }

  /**
   * The type of analysis the service performs
   */
  public String getServiceType()
  {
    return ServiceType;
  }

  public void setServiceType(String serviceType)
  {
    ServiceType = serviceType;
  }

  /**
   * The action when the service performs the analysis
   */
  public String getAction()
  {
    return Action;
  }

  public void setAction(String action)
  {
    Action = action;
  }

  /**
   * name shown to user
   * 
   * @return
   */
  public String getName()
  {
    return Name;
  }

  public void setName(String name)
  {
    Name = name;
  }

  /**
   * Detailed description (may include references, URLs, html,etc)
   * 
   * @return
   */
  public String getDescription()
  {
    return description;
  }

  public void setDescription(String description)
  {
    this.description = description;
  }

  @Override
  public boolean equals(Object object)
  {
    if (object == null || !(object instanceof UIinfo))
    {
      return false;
    }
    UIinfo other = (UIinfo) object;

    return (ServiceType == null && other.getServiceType() == null
            || ServiceType != null && other.getServiceType() != null
                    && ServiceType.equals(other.getServiceType()))
            && (Name == null && other.getName() == null
                    || Name != null && other.getName() != null
                            && Name.equals(other.getName()))
            && (Action == null && other.getAction() == null
                    || Action != null && other.getAction() != null
                            && Action.equals(other.getAction()))
            && (description == null && other.getDescription() == null
                    || description != null && other.getDescription() != null
                            && description.equals(other.getDescription()));
  }

  String Action;

  String Name;

  String description;
}